//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "form_Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmMain *frmMain;

//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
  : TForm(Owner)
{
  //
}

//---------------------------------------------------------------------------
void __fastcall TfrmMain::ConvertPDF(const AnsiString PDFFileName)
{
  typedef void (__stdcall *PDFToImageSetCode) (const char*);
  typedef int (__stdcall *PDFToImageConverter) (const char*, const char*, const char*, const char*, int, int, int, int, int, BOOL, BOOL, int, int);


  const AnsiString EMFFileName = ChangeFileExt(PDFFileName, ".emf");
  ShowInfo("Converting " + PDFFileName);
  ShowInfo("To " + EMFFileName);

  HINSTANCE LibraryInstance = LoadLibrary("pdf2image.dll");
  if (LibraryInstance == NULL)
  {
    throw Exception("Cannot load pdf2image library");
  }

  ShowInfo("pdf2image library loaded ... ");
  try
  {
    // set registration code
    PDFToImageSetCode _PDFToImageSetCode = (PDFToImageSetCode) GetProcAddress(LibraryInstance, "PDFToImageSetCode");
    if (_PDFToImageSetCode == NULL)
    {
      throw Exception("Cannot find PDFToImageSetCode procedure");
    }
    _PDFToImageSetCode("XXXXXXXXXXXXXXXXXXXXXX");

    // convert PDF
    PDFToImageConverter _PDFToImageConverter = (PDFToImageConverter) GetProcAddress(LibraryInstance, "PDFToImageConverter");
    if (_PDFToImageConverter == NULL)
    {
      throw Exception("Cannot find PDFToImageConverter procedure");
    }
    _PDFToImageConverter(
        PDFFileName.c_str(),
        EMFFileName.c_str(),
        NULL,NULL,300,300,24,1,100,FALSE,TRUE,-1,-1);
  }
  __finally
  {
    FreeLibrary(LibraryInstance);
    LibraryInstance = NULL;
    ShowInfo("Done.");
  }
}

//---------------------------------------------------------------------------
void __fastcall TfrmMain::ShowInfo(const AnsiString Info)
{
  mmInfo->Lines->Add(Info);
}

//---------------------------------------------------------------------------
void __fastcall TfrmMain::btConvertPDFClick(TObject *Sender)
{
  if (odPDF->Execute())
  {
    ConvertPDF(odPDF->FileName);
  }
}
//---------------------------------------------------------------------------
